#pragma once

#include "wimp_basics.h"

#ifdef __cplusplus
extern "C"
{
#endif

  typedef union
  {
    struct
    {
      unsigned ifContainsText : 1; // 0
      unsigned ifIsSprite : 1; // 1
      unsigned ifHasBorder : 1; // 2
      unsigned ifContentsCentredHorzontally : 1; // 3
      unsigned ifContentsCentredVertically : 1; // 4
      unsigned ifFilledBackground : 1; // 5
      unsigned ifAntialisedFont : 1; // 6
      unsigned ifNeedsHelp : 1; // 7
      unsigned ifDataIndirected : 1; // 8
      unsigned ifRightJustified : 1; // 9
      unsigned ifDontCancelESG : 1; // 10
      unsigned ifHalfSizeSprite : 1; // 11
      unsigned ifIconButtonType : 4; // 12 .. 15
      unsigned ifESGMask : 5; // 16 .. 20
      unsigned ifInverted : 1; // 21
      unsigned ifShaded : 1; // 22
      unsigned ifDelted : 1; // 23
      unsigned ifForegroundColour : 4; // 24 .. 27
      unsigned ifBackgroundColour : 4; // 28..31
    };
    unsigned int ifFlags;
  } sIconFlags; // if

  typedef struct
  {
    unsigned : 24;
    unsigned ifFontHandle : 8;
  } sIconFontFlags;

  typedef union
  {
    unsigned int uiaIconData[3];
    byte baIconData[12];
    char caIconData[12];
    struct
    {
      char* pcaTextbuffer;
      const char* kpcaValidationString;
      int iBufferLength;
    } indirectedText;
    struct
    {
      union
      {
        const char* kpcaSpriteName;
        const byte* kpbaSprite;
      };
      const byte* kpbaSpriteBlock;
      int iSpriteNameLength;
    } indirectedSpriteOnly;
  } uIconData; // id

  typedef struct
  {
    tWindowHandle whWindow;
    tLocation lMinimum;
    tLocation lMaximum;
    union
    {
      sIconFlags ifFlags;
      sIconFontFlags ifFontFlags;
      unsigned int uiFlags;
    };
    uIconData idData;
  } tIconCreateBlock; // icb

#define WIMP_SPRITEAREA ((byte*)-1)

  typedef enum
  {
    ibtIgnoreClicks = 0,
    ibtNotifyContinuously = 1,
    ibtClickNotifiesAutoRepeat = 2,
    ibtClickNotifiedOnce = 3,
    ibtClickSelectsReleaseNotifies = 4,
    ibtClickSelectsDoubleClickNotifies = 5,
    ibtClickNotifiesOnceAndDrag = 6,
    ibtClickSelectsReleaseNotifiesAndDrag = 7,
    ibtClickSelectsDoubleClickNotifiesAndDrag = 8,
    ibtClickDragDoubleClick = 9,
    ibtClickSelectsReturnsAndDrag = 10,
    ibtClickGainCaretAndDrag = 14,
    ibtClickGainCaret = 15
  } eIconButtonTypes; // ibt

  const tIconHandle wimp_createicon(const tIconCreateBlock* kpicbIcon);
  void wimp_deleteicon(const tWindowHandle kwhWindow, const tIconHandle kihIcon);

#ifdef __cplusplus
}
#endif
